## debian-cd 3.1.4

=== Makefile ===
#!/usr/bin/make -f

# Main Makefile for debian-cd
#
# Copyright 1999 Rapha?l Hertzog <hertzog@debian.org>
# See the README file for the license
#
# Significantly modified 2005-2006 Steve McIntyre <93sam@debian.org>
# for multi-arch and mixed bin/src discs
#
# The environment variables must have been set
# before. For this you can source the CONF.sh 
# file in your shell


## DEFAULT VALUES
ifndef VERBOSE_MAKE
Q=@
endif
ifndef TASK
TASK=Debian-generic
endif
ifndef MKISOFS
export MKISOFS=$(shell which genisoimage mkisofs | head -1)
endif
ifndef MKISOFS_OPTS
#For normal users
MKISOFS_OPTS=-r
#For symlink farmers
#MKISOFS_OPTS=-r -F .
endif
ifndef HOOK
HOOK=$(BASEDIR)/tools/$(CODENAME).hook
endif

export BUILD_DATE=$(shell date -u +%Y%m%d-%H:%M)
export ARCHES_NOSRC=$(shell echo $(ARCHES) | sed 's/source//')
ifeq ($(ARCHES),source)
	export SOURCEONLY=yes
endif
ifeq ($(shell echo $(ARCHES) | sed 's/.*source.*/1/'),1)
	export INC_SOURCE=yes
endif

## Internal variables  
apt=$(BASEDIR)/tools/apt-selection
sort_deps=$(BASEDIR)/tools/sort_deps
md5sum=md5sum
jigdo_cleanup=$(BASEDIR)/tools/jigdo_cleanup
grab_md5=$(BASEDIR)/tools/grab_md5
make_image=$(BASEDIR)/tools/make_image
merge_package_lists=$(BASEDIR)/tools/merge_package_lists
update_popcon=$(BASEDIR)/tools/update_popcon
update_tasks=$(BASEDIR)/tools/update_tasks
grab_source_list=$(BASEDIR)/tools/grab_source_list
which_deb=$(BASEDIR)/tools/which_deb

BDIR=$(TDIR)/$(CODENAME)
TASKDIR=$(BDIR)/tasks
ADIR=$(APTTMP)
DB_DIR=$(BDIR)/debootstrap

export DEBOOTSTRAP_DIR := $(DB_DIR)/usr/lib/debootstrap
export PATH := $(DB_DIR)/usr/sbin:$(PATH)
export BDIR
export TASKDIR

## DEBUG STUFF ##

default:
	@echo "Please refer to the README file for more information"
	@echo "about the different targets available."

## CHECKS ##

# Basic checks in order to avoid problems
ok:
ifndef TDIR
	@echo TDIR undefined -- set up CONF.sh; false
endif
ifndef BASEDIR
	@echo BASEDIR undefined -- set up CONF.sh; false
endif
ifndef MIRROR
	@echo MIRROR undefined -- set up CONF.sh; false
endif
ifndef ARCHES
	@echo ARCHES undefined -- set up CONF.sh; false
endif
ifndef CODENAME
	@echo CODENAME undefined -- set up CONF.sh; false
endif
ifndef OUT
	@echo OUT undefined -- set up CONF.sh; false
endif
ifdef NONFREE
ifdef EXTRANONFREE
	@echo Never use NONFREE and EXTRANONFREE at the same time; false
endif
endif
	@if [ $(DISKTYPE) = "NETINST" -o $(DISKTYPE) = "BC" ] ; then \
		if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
			echo "Including source is not supported on a netinst/bc CD"; \
			false; \
		fi; \
	fi

## INITIALIZATION ##

# Creation of the directories needed
init: ok $(OUT) $(TDIR) $(BDIR) $(ADIR) $(TASKDIR) $(BDIR)/DATE $(DB_DIR) unstable-map
$(OUT):
	$(Q)mkdir -p $(OUT)
$(TDIR):
	$(Q)mkdir -p $(TDIR)
$(BDIR):
	$(Q)mkdir -p $(BDIR)
$(ADIR):
	$(Q)mkdir -p $(ADIR)
$(TASKDIR):
ifneq ($(ARCHES),source)
	$(Q)echo "Updating task files..."
	$(Q)mkdir -p $(TASKDIR)
	$(Q)echo "- copying task files from 'tasks/$(DI_CODENAME)/'"
	$(Q)cp -r $(BASEDIR)/tasks/$(CODENAME)/* $(TASKDIR)
	$(Q)echo "- copying firwmare task file from 'tasks/firmware'"
	$(Q)cp -r $(BASEDIR)/tasks/firmware $(TASKDIR)
	$(Q)echo "- task.languages: using 'tasks/$(DI_CODENAME)/$(TASK_LANGLIST)'"
	$(Q)cp $(BASEDIR)/tasks/$(DI_CODENAME)/$(TASK_LANGLIST) \
		$(TASKDIR)/task.languages
	$(Q)echo "- generating dynamic task files"
	$(Q)set -e; cd $(TASKDIR); \
		$(BASEDIR)/tools/update_tasks; \
		$(BASEDIR)/tools/generate_di_list; \
		$(BASEDIR)/tools/generate_di+k_list
endif
$(BDIR)/DATE:
	$(Q)date '+%Y%m%d' > $(BDIR)/DATE

ifdef MIRROR
LATEST_DB := $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) debootstrap)
$(DB_DIR): $(LATEST_DB)
	@rm -rf $(DB_DIR)
	$(Q)dpkg -x $(LATEST_DB) $(DB_DIR)
	$(Q)if [ ! -e $(DEBOOTSTRAP_DIR) ] ; then \
		ln -sf share $(DB_DIR)/usr/lib ; \
	fi
endif

# Make sure unstable/sid points to testing/squeeze, as there is no build
# rule for unstable/sid.
unstable-map:
	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
		ln -s squeeze $(BASEDIR)/data/sid ; \
	fi
	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
		ln -s squeeze $(BASEDIR)/tools/boot/sid ; \
	fi

#################
## CLEAN RULES ##
#################

# Cleans the current arch tree (but not packages selection info)
clean: ok dir-clean
dir-clean:
	$(Q)rm -rf $(BDIR)/CD[1234567890]*
	$(Q)rm -rf $(TASKDIR)
	$(Q)rm -f $(BDIR)/*.filelist*
	$(Q)rm -f  $(BDIR)/packages-stamp $(BDIR)/upgrade-stamp $(BDIR)/md5-check

# Completely cleans the current arch tree
realclean: distclean
distclean: ok clean
	$(Q)echo "Cleaning the build directory"
	$(Q)rm -rf $(ADIR)
	$(Q)rm -rf $(TDIR)

####################
## STATUS and APT ##
####################

$(CODENAME)_status: ok init
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		echo "Using the provided status file for $(CODENAME)-$$ARCH ..."; \
		cp $(BASEDIR)/data/$(CODENAME)/status.$$ARCH $(ADIR)/$(CODENAME)-$$ARCH/status 2>/dev/null || $(MAKE) status || $(MAKE) correctstatus ; \
	done

# Regenerate the status file with only packages that
# are of priority standard or higher
status: init $(ADIR)/status
$(ADIR)/status:
	@echo "Generating a fake status file for apt-get and apt-cache..."
	$(Q)for ARCH in $(ARCHES); do \
		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH/apt/preferences.d; \
		if [ $$ARCH = "source" -o "$(INSTALLER_CD)" = "1" -o "$(INSTALLER_CD)" = "2" -o "$(INSTALLER_CD)" = "C" ];then \
			:> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
		else \
			zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$$ARCH/Packages.gz | \
			perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; print if (/^Priority: (required|important|standard)/m or /^Section: base/m);' \
			>> $(ADIR)/$(CODENAME)-$$ARCH/status ; \
		fi; \
	done;
	:> $(ADIR)/status
    # Updating the apt database
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) update; \
	done
    #
    # Checking the consistency of the standard system
    # If this does fail, then launch make correctstatus
    #
	$(Q)for ARCH in $(ARCHES); do \
		export ARCH=$$ARCH; \
		$(apt) check || $(MAKE) correctstatus; \
	done

# Only useful if the standard system is broken
# It tries to build a better status file with apt-get -f install
correctstatus: status apt-update
    # You may need to launch correctstatus more than one time
    # in order to correct all dependencies
    #
    # Removing packages from the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) deselected -f install`; do \
				echo $$ARCH:$$i; \
				perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
				$(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
		done; \
    fi
    #
    # Adding packages to the system :
	$(Q)set -e; \
	if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES_NOSRC); do \
			export ARCH=$$ARCH; \
			for i in `$(apt) selected -f install`; do \
				echo $$ARCH:$$i; \
				$(apt) cache dumpavail | perl -000 -ne \
				"s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m; \
				print if /^Package: \Q$$i\E\s*\$$/m;" \
				>> $(ADIR)/$(CODENAME)-$$ARCH/status; \
			done; \
		done; \
    fi
    #
    # Showing the output of apt-get check :
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCH=$$ARCH $(apt) check; \
	done

apt-update: status
	$(Q)if [ "$(ARCHES)" != "source" ] ; then \
		for ARCH in $(ARCHES); do \
			echo "Apt-get is updating its files ..."; \
			ARCH=$$ARCH $(apt) update; \
		done; \
    fi

## GENERATING LISTS ##

# Deleting the list only
deletelist: ok
	$(Q)-rm $(BDIR)/rawlist
	$(Q)-rm $(BDIR)/list

packagelists: ok apt-update genlist

# Build the raw list (cpp output) with doubles and spaces
$(BDIR)/rawlist:
# Dirty workaround for saving space, we add some hints to break ties.
# This is just a temporal solution, sort_deps should be a little bit less
# silly so that this is not needed. For more info have a look at
# http://lists.debian.org/debian-cd/2004/debian-cd-200404/msg00093.html
	$(Q)if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		if [ "$(INSTALLER_CD)"x = "1"x ] ; then \
			: ; \
		elif [ "$(INSTALLER_CD)"x = "2"x -o "$(INSTALLER_CD)"x = "C"x ] ; then \
			echo -e "mawk" >>$(BDIR)/rawlist; \
		else \
			echo -e "mawk\nexim4-daemon-light" >>$(BDIR)/rawlist; \
		fi; \
	fi

	$(Q)if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		if [ _$(INSTALLER_CD) != _1 ]; then \
			for ARCH in $(ARCHES_NOSRC); do \
				BINCLUDE=`[ -n "$(BASE_INCLUDE)" ] && cat $(BASE_INCLUDE) | tr "\n" "," | sed 's!,$$!!g'`; \
				[ -z "$$BINCLUDE" ] || BINCLUDE="--include=$$BINCLUDE"; \
				BEXCLUDE=`[ -n "$(BASE_EXCLUDE)" ] && cat $(BASE_EXCLUDE) | tr "\n" "," | sed 's!,$$!!g'`; \
				[ -z "$$BEXCLUDE" ] || BEXCLUDE="--exclude=$$BEXCLUDE"; \
				debootstrap --arch $$ARCH \
				            --print-debs \
				            $$BINCLUDE $$BEXCLUDE \
				            $(CODENAME) \
				            $(TDIR)/debootstrap.tmp \
				            file:$(MIRROR) \
			                $(DEBOOTSTRAP_SCRIPT) 2>/dev/null \
				    | tr ' ' '\n' > $(BDIR)/debootstrap-list; \
				cat $(BDIR)/debootstrap-list >>$(BDIR)/rawlist; \
				rm -rf $(TDIR)/debootstrap.tmp; \
			done; \
		fi; \
	fi

	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCHDEFS="$$ARCHDEFS -D ARCH_`echo $$ARCH | sed 's/-/_/'`"; \
		ARCHUNDEFS="$$ARCHUNDEFS -U $$ARCH"; \
	done; \
	for VARIANT in $(VARIANTS); do \
		VARIANTDEFS="$$VARIANTDEFS -D VARIANT_$$VARIANT"; \
	done; \
	if [ "$(FORCE_FIRMWARE)"x != "0"x ] ; then \
		ARCHDEFS="$$ARCHDEFS -DFORCE_FIRMWARE"; \
	fi; \
	if [ "$(EXCLUDE_486_KERNEL)"x = "1"x ] ; then \
		ARCHDEFS="$$ARCHDEFS -DARCH_i386_EXCLUDE_486_KERNEL"; \
	fi; \
	if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
		cat $(TASKDIR)/$(TASK) | \
		cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS $$VARIANTDEFS\
	   		$$ARCHUNDEFS -U i386 -U linux -U unix \
		    -DFORCENONUSONCD1=0 \
		    -I $(TASKDIR) - - >> $(BDIR)/rawlist; \
	fi

    # If we're *only* doing source, then we need to build a list of all the
    # available source packages. Deliberately ignore the tasks too.
	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
		awk '/^Package:/ {print $$2}' $(ADIR)/$(CODENAME)-source/apt-state/lists/*Sources | \
			sort -u > $(BDIR)/rawlist; \
	fi
#	ls -al $(BDIR)/rawlist

# Generate the complete listing of packages from the task
# Build a nice list without doubles and without spaces
genlist: ok $(BDIR)/list
$(BDIR)/list: $(BDIR)/rawlist
	@echo "Generating the complete list of packages to be included in $(BDIR)/list..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist \
		  > $(BDIR)/list

## IMAGE BUILDING ##

image-trees: ok genlist
    # Use sort_deps to do the dependency sorting
	$(Q)for ARCH in $(ARCHES_NOSRC); do \
		ARCH=$$ARCH $(sort_deps) $(BDIR)/list; \
	done
	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
		$(grab_source_list) $(BDIR) $(ADIR) $(BDIR)/list $(BDIR)/packages; \
	else \
		$(merge_package_lists) $(BDIR) $(ADIR) "$(ARCHES)" $(BDIR)/packages; \
	fi
	$(Q)if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
		grep ^source $(BDIR)/packages > $(BDIR)/packages.source; \
	fi
	$(Q)$(BASEDIR)/tools/make_disc_trees.pl $(BASEDIR) $(MIRROR) $(TDIR) $(CODENAME) "$(ARCHES)" $(MKISOFS)

images: ok $(OUT) $(BDIR)/md5-check
	$(Q)$(make_image) "$(BDIR)" "$(ARCHES)" "$(OUT)" "$(DEBVERSION)" "$(MIRROR)" "$(MKISOFS)" "$(MKISOFS_OPTS)" "$(JIGDO_OPTS)" "$(jigdo_cleanup)"

check-number-given:
	@test -n "$(CD)" || (echo "Give me a CD=<num> parameter !" && false)

# Generate only one image number $(CD)
image: check-number-given images

# Calculate the md5sums for the images (if available), or get from templates
imagesums:
	$(Q)$(BASEDIR)/tools/imagesums $(OUT) $(SUMS_EXTENSION)

## MISC TARGETS ##

$(BDIR)/md5-check: mirrorcheck	

mirrorcheck: ok
	$(Q)$(grab_md5) $(MIRROR) "$(ARCHES)" $(CODENAME) $(DI_CODENAME) $(BDIR)/md5-check
	$(Q)for ARCH in $(ARCHES); do \
		if [ -e $(BASEDIR)/data/$(CODENAME)/$$ARCH/extra-sources ]; then \

=== debian/changelog ===
debian-cd (3.1.4) unstable; urgency=low

  [ Frans Pop ]
  * Cleanup of packages included for bootable CDs (generate_d-i+k_list):
    - libsysfs2 workaround is no longer needed;
    - discover is no longer used anywhere;
    - include grub-legacy instead of grub;
    - pcmcia-cs has been fully replaced with pcmciautils.
  * Exclude udebs for X.Org-based version of the Graphical Installer.
  * Excluding reiserfs4 udebs is not needed for Squeeze.
  * Include pciutils on installation CDs.
  * Only include a symlink for the suite actually specified in the
    Release file. Closes: #590993

  [ Karl Goetz ]
  * Rename log.sort_deps* to sort_deps*.log for better consistency.
    Closes: #571591
  * Minor tweaks to Debian packaging to make lintian happy.
    Closes: #592932
  * Minor whitespace/wording fixes for the README file. Closes: #592933
  * Change the default for NORECOMMENDS to 1 for consistency with
    NOSUGGESTS. Closes: #598196
  * Documentation patches

  [ Steve McIntyre ]
  * Rename log.add_packages to add_packages.log
  * Add dependency on dpkg-dev for dpkg-architecture. Closes: #574879
  * Add support for forcing firmware packages onto CD#1:
    + Add "FORCE_FIRMWARE=1" to CONF.sh to turn this on
    + Will pick up on packages in the "firmware" task and install them
    + Will also add sym-links to them in CD1/firmware so that new d-i code
      can find them easily.
    + Will add a short sentence into README.html/README.txt
  * Add top-level control of which checksums are desired for output images
    see the CHECKSUMS setting in CONF.sh
  * Fix some bashisms in tools/apt-selection.
  * When generating both iso and jigdo files, make sure that the iso files
    are at least as new as the jigdo files, as this helps people mirroring.
    Closes: #587774
  * On release builds, use the full version number including all the dots
    (e.g. 6.0.0 for the squeeze release instead of 600).
  * Update loadlin kernel parameters to match d-i values. Thanks to Samuel
    Thibault for the patch. Closes: #594267
  * Fix support for alternative boot splash images. Thanks to Tony Awtrey
    for the patch. Closes: #537368
  * Include the acpi package for all x86 media types. Closes: #475243
  * Include the wpasupplicant package on netinsts and larger. Closes: #593914
  * Include kbd on first CD rather than console-tools. Closes: #514654
  * Added dedication to Frans Pop.

  [ Ian Campbell ]
  * boot-x86: detect duplicates in the extra images used for installation
    and replace with hard links.
  * CONF.sh: Don't reset the value of $VARIANTS by default.

  [ Aurelien Jarno ]
  * Add support for the kfreebsd ports. Closes: #593629
  * Add debian-ports-archive-keyring-udeb and
    emdebian-archive-keyring-udeb to the exclude list - they should be in
    the initrd already.
  * Don't exclude reiserfsprogs-udeb, as rescue-mode depends on it.
    Closes: #593972

  [ Petter Reinholdtsen ]
  * Support replacing the g-i image with ones own image. Closes: #601189

  [ Holger Levsen ]
  * Start work on Debian Edu images.

  [ Otavio Salvador ]
  * squeeze: include zlib-modules for i386 images

 -- Steve McIntyre <93sam@debian.org>  Sun, 14 Nov 2010 15:37:24 +0000

## debian-cd 3.1.5

=== Makefile ===
--- 
+++ 
@@ -40,6 +40,16 @@
 endif
 ifeq ($(shell echo $(ARCHES) | sed 's/.*source.*/1/'),1)
 	export INC_SOURCE=yes
+endif
+
+UNDER_ARCHES=$(shell echo $(ARCHES) | sed 's/\ /_/g')
+ARCH_MKISOFS = ${${UNDER_ARCHES}_MKISOFS}
+ARCH_MKISOFS_OPTS = ${${UNDER_ARCHES}_MKISOFS_OPTS}
+ifneq (${ARCH_MKISOFS},)
+    MKISOFS = ${ARCH_MKISOFS}
+endif
+ifneq (${ARCH_MKISOFS_OPTS},)
+    MKISOFS_OPTS = ${ARCH_MKISOFS_OPTS}
 endif
 
 ## Internal variables  
@@ -363,7 +373,7 @@
 	$(Q)if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
 		grep ^source $(BDIR)/packages > $(BDIR)/packages.source; \
 	fi
-	$(Q)$(BASEDIR)/tools/make_disc_trees.pl $(BASEDIR) $(MIRROR) $(TDIR) $(CODENAME) "$(ARCHES)" $(MKISOFS)
+	$(Q)$(BASEDIR)/tools/make_disc_trees.pl $(BASEDIR) $(MIRROR) $(TDIR) $(CODENAME) "$(ARCHES)" "$(MKISOFS)" "$(MKISOFS_OPTS) $(JIGDO_OPTS)"
 
 images: ok $(OUT) $(BDIR)/md5-check
 	$(Q)$(make_image) "$(BDIR)" "$(ARCHES)" "$(OUT)" "$(DEBVERSION)" "$(MIRROR)" "$(MKISOFS)" "$(MKISOFS_OPTS)" "$(JIGDO_OPTS)" "$(jigdo_cleanup)"
@@ -378,11 +388,3 @@
 imagesums:
 	$(Q)$(BASEDIR)/tools/imagesums $(OUT) $(SUMS_EXTENSION)
 
-## MISC TARGETS ##
-
-$(BDIR)/md5-check: mirrorcheck	
-
-mirrorcheck: ok
-	$(Q)$(grab_md5) $(MIRROR) "$(ARCHES)" $(CODENAME) $(DI_CODENAME) $(BDIR)/md5-check
-	$(Q)for ARCH in $(ARCHES); do \
-		if [ -e $(BASEDIR)/data/$(CODENAME)/$$ARCH/extra-sources ]; then \

=== debian/changelog ===
debian-cd (3.1.5) unstable; urgency=high

  [ Steve McIntyre ]
  * Final upload for squeeze.
  * Pass the base mkisofs options into make_disc_trees too.
  * Switch to --iso-level 4 for powerpc images to make them work better
    with POWER machines. Thanks to Milan Kupcevic for the patch.
    Closes: #603536
  * Add code to make isohybrid images for i386/amd64:
    + Makefile: Add support for overriding the MKISOFS and MKISOFS_OPTS
      variables on a per-arch basis
    + CONF.sh: add working examples for this
    + CONF.sh: fix up the -jigdo-min-file-size option to use 1024 instead
      of 0; genisoimage used to fix this up, but xorriso doesn't.
    + tools/boot/squeeze/boot-x86: if configured to use xorriso, add the
      extra command line options to add the isohybrid MBR. Also work
      around a difference in ISO directory naming between genisoimage and
      xorriso.
    + Closes: #551951
  * Drop the recommended size for BD-ROMs slightly, on the recommendation
    of Thomas Schmitt. This will make it more likely that we'll fit on
    all media.

 -- Steve McIntyre <93sam@debian.org>  Wed, 02 Feb 2011 23:37:54 +0000

=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Raphael Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>, Frans Pop <fjp@debian.org>
Build-Depends: debhelper (>= 5)
Build-Depends-Indep: tofrodos
Standards-Version: 3.9.1
Vcs-Svn: svn://svn.debian.org/debian-cd/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-cd/trunk?op=log

Package: debian-cd
Architecture: all
Depends: ${misc:Depends}, curl, perl, dpkg-dev, cpp, libdigest-md5-perl, tofrodos, apt (>= 0.3.11.1), make, genisoimage, lynx-cur | lynx, grep-dctrl, bc, libcompress-zlib-perl
Recommends: hfsutils, netpbm, syslinux-common
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

## debian-cd 3.1.7

=== Makefile ===
--- 
+++ 
@@ -133,8 +133,6 @@
 	$(Q)mkdir -p $(TASKDIR)
 	$(Q)echo "- copying task files from 'tasks/$(DI_CODENAME)/'"
 	$(Q)cp -r $(BASEDIR)/tasks/$(CODENAME)/* $(TASKDIR)
-	$(Q)echo "- copying firwmare task file from 'tasks/firmware'"
-	$(Q)cp -r $(BASEDIR)/tasks/firmware $(TASKDIR)
 	$(Q)echo "- task.languages: using 'tasks/$(DI_CODENAME)/$(TASK_LANGLIST)'"
 	$(Q)cp $(BASEDIR)/tasks/$(DI_CODENAME)/$(TASK_LANGLIST) \
 		$(TASKDIR)/task.languages
@@ -143,9 +141,14 @@
 		$(BASEDIR)/tools/update_tasks; \
 		$(BASEDIR)/tools/generate_di_list; \
 		$(BASEDIR)/tools/generate_di+k_list
+ifeq ($(FORCE_FIRMWARE),1)
+	# Generate firmware task file using the contents of the archive
+	$(Q)$(BASEDIR)/tools/generate_firmware_task "$(ARCHES)" $(TASKDIR)/firmware
+endif
 endif
 $(BDIR)/DATE:
-	$(Q)date '+%Y%m%d' > $(BDIR)/DATE
+	$(Q)date -u '+%Y%m%d' > $(BDIR)/DATE
+	$(Q)date -u '+%Y%m%dT%H%M%SZ' > $(BDIR)/DATE-zulu
 
 ifdef MIRROR
 LATEST_DB := $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) debootstrap)
@@ -157,14 +160,14 @@
 	fi
 endif
 
-# Make sure unstable/sid points to testing/squeeze, as there is no build
+# Make sure unstable/sid points to testing/wheezy, as there is no build
 # rule for unstable/sid.
 unstable-map:
 	$(Q)if [ ! -d $(BASEDIR)/data/sid ] ; then \
-		ln -s squeeze $(BASEDIR)/data/sid ; \
+		ln -s wheezy $(BASEDIR)/data/sid ; \
 	fi
 	$(Q)if [ ! -d $(BASEDIR)/tools/boot/sid ] ; then \
-		ln -s squeeze $(BASEDIR)/tools/boot/sid ; \
+		ln -s wheezy $(BASEDIR)/tools/boot/sid ; \
 	fi
 
 #################
@@ -326,7 +329,7 @@
 	for VARIANT in $(VARIANTS); do \
 		VARIANTDEFS="$$VARIANTDEFS -D VARIANT_$$VARIANT"; \
 	done; \
-	if [ "$(FORCE_FIRMWARE)"x != "0"x ] ; then \
+	if [ "$(FORCE_FIRMWARE)"x = "1"x ] ; then \
 		ARCHDEFS="$$ARCHDEFS -DFORCE_FIRMWARE"; \
 	fi; \
 	if [ "$(EXCLUDE_486_KERNEL)"x = "1"x ] ; then \
@@ -384,7 +387,3 @@
 # Generate only one image number $(CD)
 image: check-number-given images
 
-# Calculate the md5sums for the images (if available), or get from templates
-imagesums:
-	$(Q)$(BASEDIR)/tools/imagesums $(OUT) $(SUMS_EXTENSION)
-

=== debian/changelog ===
debian-cd (3.1.7) unstable; urgency=low

  [ Ben Hutchings ]
  * In the boot prompt for powerpc, make install64 more prominent.
    Closes: #614583

  [ Steve McIntyre ]
  * Merge update-cd changes back from the squeeze branch:
    + Remove the old non-US stuff from it, it's not been needed in years.
    + Cope with .bz2 source files too.
    + Merged and simplified the old functionality from scansources.old
      and scanpackages.old into the new script create_control.
    + Run the mkisofs step *outside* of "set -e" so that we can actually
      report errors instead of silently failing.
    + Split out the code for starting a new disc into a function.
    + Pick up on a potential bug: if we finish the last (expected) disc with
      a backed-out file, make sure we create another image to include that
      file too.
  * Update make_disc_trees.pl and which_deb to cope with different
    types of source file, and clean up the code in that area.
  * tools/make_image: generate list files while we have the CD trees
    available
  * update the URL for downloading s390 d-i dailies.
  * Add linux-image-2.6-686-bigmem to tasks/<release>/interesting-fromcd23
    to try and put that on i386 image sets before linux-image-amd64.
    Closes: #622622
  * update the URL for downloading i386 d-i dailies.
  * update the URL for downloading armel d-i dailies.
  * tools/grab_md5:
    + Improve Packages and Sources file parsing;
    + Cope with differently-formed files that are still valid
      (don't assume field ordering).
    + Switch from awk to perl makes things much faster too!
    + Make arch handling more generic - instead of having to list all
      arches, allow a wildcard and then check for lack of Packages.gz files
  * tools/make-firmware-image: Rather than use the firmware task which
    gets out of date, look for firmware/microcode files directly in the
    Packages file. Check for things installing in /lib/firmware, and add
    those packages.
  * Remove the checked-in firmware task altogether, as it's not
    useful. Generate it when needed using the new script
    tools/generate_firmware_task.
  * Add apt-offline to tasks/wheezy/forcd1 to bring it onto CD#1.
    Closes: #630805
  * Add links to snapshot.debian.org into jigdo files. 

  [ Aurelien Jarno ]
  * Add support for hurd-i386. Closes: #619211

 -- Steve McIntyre <93sam@debian.org>  Tue, 07 Jun 2011 23:03:42 +0100

debian-cd (3.1.6) unstable; urgency=low

  [ Raphaël Hertzog ]
  * Add the missing accent in my family name in Uploaders.
  * Drop Frans Pop from Uploaders, RIP.

  [ Steve McIntyre ]
  * Start wheezy development, doing "svn cp squeeze wheezy" and
    "s/squeeze/wheezy/" in various places.
  * Add support for over-riding disc size on demand, used for some of the
    squeeze release builds.
  * Add disk size definitions for 1/2/4/8 GB USB sticks.
  * Extend the size-override code to allow to override an individual disc
    in the set (e.g. to make the first DVD fit on a 4GB USB
    stick). Closes: #612074
  * Special-case builds of source-only discs: if we think we've
    overflowed the disc size, try to carry on for a few more packages
    to get closer to actually filling the disc. Closes: #613751.
  * Path to sparc daily builds has changed.
  * armel hasn't booted off CD in ages for us; comment out the DI_WWW_HOME
    definition to stop the mirror script complaining.
  * Add more checksum types to generated Release files; go from md5 only
    to md5, sha1, sha256 and sha512.
  * tools/start_new_disc: tone down messages about missing
    {BASE,UDEB}_{INCLUDE,EXCLUDE} files from ERROR to WARNING.
    Closes: #615043

  [ Otavio Salvador ]
  * Add btrfs-tools on required packages by installer. Closes: #612007.

  [ Didier Raboud ]
  * Remove win32-loader standalone flavours from the tools/ directory on
    x86. Closes: #612224

 -- Steve McIntyre <93sam@debian.org>  Fri, 04 Mar 2011 14:56:50 +0000

=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Raphaël Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>
Build-Depends: debhelper (>= 5)
Build-Depends-Indep: tofrodos
Standards-Version: 3.9.1
Vcs-Svn: svn://svn.debian.org/debian-cd/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-cd/trunk?op=log

Package: debian-cd
Architecture: all
Depends: ${misc:Depends}, curl, perl, dpkg-dev, cpp, libdigest-md5-perl, libdigest-sha-perl, tofrodos, apt (>= 0.3.11.1), make, genisoimage, lynx-cur | lynx, grep-dctrl, bc, libcompress-zlib-perl
Recommends: hfsutils, netpbm, syslinux-common
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Christoph Lameter.

build: build-stamp
build-stamp:
	dh_testdir
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp install-stamp
	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	cp -r contrib tools tasks data Makefile README README.devel build.sh \
              build_all.sh update-cd easy-build.sh README.easy-build \
              debian/debian-cd/usr/share/debian-cd/
	cp debian/CONF.sh debian/debian-cd/etc/debian-cd/conf.sh
	ln -sf /etc/debian-cd/conf.sh \
               debian/debian-cd/usr/share/debian-cd/CONF.sh
	find debian/debian-cd -name '.svn' | xargs -r rm -rf
	find debian/debian-cd/usr/share/debian-cd/tools/boot \
	  \( -name 'boot-*' -o -name 'post-boot-*' \) -a \! -name '*.txt' \
	  -a \! -name '*.calc' -a \! -name boot-x86 -a \! -name boot-kfreebsd | xargs chmod 0755
	cd debian/debian-cd/usr/share/debian-cd/contrib && chmod 755 cronjob.* ftp.cron \
		generate_firmware_images iso_run jigdo-watcher \
		merge-sums mkjigsnap mklist mktorrent \
		report_build_error testingcds 

	touch install-stamp

# Build architecture-dependent files here.
binary-arch: build install
# We have nothing to do by default.

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installdocs README* DEDICATION.txt
	dh_installexamples
	dh_installmenu
	dh_installcron
	dh_installman
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## debian-cd 3.1.9

=== Makefile ===
--- 
+++ 
@@ -85,6 +85,9 @@
 
 # Basic checks in order to avoid problems
 ok:
+ifdef FORCE_FAIL
+	@echo Debug variable FORCE_FAIL defined -- abort now; false
+endif
 ifndef TDIR
 	@echo TDIR undefined -- set up CONF.sh; false
 endif
@@ -133,9 +136,6 @@
 	$(Q)mkdir -p $(TASKDIR)
 	$(Q)echo "- copying task files from 'tasks/$(DI_CODENAME)/'"
 	$(Q)cp -r $(BASEDIR)/tasks/$(CODENAME)/* $(TASKDIR)
-	$(Q)echo "- task.languages: using 'tasks/$(DI_CODENAME)/$(TASK_LANGLIST)'"
-	$(Q)cp $(BASEDIR)/tasks/$(DI_CODENAME)/$(TASK_LANGLIST) \
-		$(TASKDIR)/task.languages
 	$(Q)echo "- generating dynamic task files"
 	$(Q)set -e; cd $(TASKDIR); \
 		$(BASEDIR)/tools/update_tasks; \
@@ -387,3 +387,5 @@
 # Generate only one image number $(CD)
 image: check-number-given images
 
+# Calculate the md5sums for the images (if available), or get from templates
+imagesums:

=== debian/changelog ===
debian-cd (3.1.9) unstable; urgency=low

  [ Steve McIntyre ]
  * Add s390x as a known architecture, merging common s390/s390x boot
    setup scripts.
  * Add dependency on xorriso. Closes: #673656
  * Describe discs appropriately depending on the kernel used.
    Closes: #673975
  * Clean up handling of environment variable handling in perl tools.
  * Switch over to working with new task-* metapackages. Closes: #672941
  * Add espeakup to forcd1, so we get speech synthesis for a11y early on full
    CD/DVD sets. Closes: #678064
  * Fix installer priority handling on pegasos. Closes: #679798.
    Thanks to Milan Kupcevic for the patch.
  * Add gtk initrd to hurd-i386 images. Closes: #635260
    Thanks to Samuel Thibault for the patch.
  * Updated all the latest in-use scripts and config in the contrib dir.

 -- Steve McIntyre <93sam@debian.org>  Thu, 05 Jul 2012 18:32:04 -0600

debian-cd (3.1.8) unstable; urgency=low

  [ Steve McIntyre ]
  * Switch i386 kernel flavours again on advice from Ben:
    + Removed all mention of 686-bigmem as it's now gone
    + Added 686-pae onto CD#1 in place of 686
    + Leave the 486 kernel on CD#1 still, for people who can't use 686-pae
    + Add zfsutils into the generate_d-i+k_list for kfreebsd users.
  * Add support for translated package description files. Closes: #495102
    + Add needed dependency on bzip2
    + Other minor cleanups in tools/make_disc_trees.pl
  * Fix "expert" mode in yaboot for powerpc. Closes: #636265. Thanks to
    Milan Kupcevic for the patch.
  * Update list of Linux kernel packages. Closes: #648690. Thanks to Ben
    Hutchings for the patch.
  * Remove lots of old stuff neither needed nor supported any more:
    + removed architectures: alpha arm hppa
    + removed releases: etch lenny
    + removed unversioned data/sparc and data/yaboot, versioned
      equivalents are in place already.
  * tools/generate_firmware_task: Add LOCALDEBS support
  * Add more armel kernel flavours
  * Add armhf as a known architecture, merging common armel/armhf boot
    setup scripts.
  * Remove hppa boot script, unsupported now.
  * Tweak command line options for creating source images: add -joliet-long

  [ Joey Hess ]
  * Read tasksel's debian-tasks.desc from its new location.

  [ Ian Campbell ]
  * Rename "xm-debian.cfg" to just "debian.cfg" for Xen config.

  [ Raphaël Hertzog ]
  * Changes triggered by various lintian warnings:
    + Switch to “3.0 (native)” source format to get rid of .svn
      directories in the source package (when built from the svn checkout
      directly)
    + Support build-arch/build-indep targets in debian/rules.
    + Drop executable rights from tools/boot/wheezy/boot-hurd
      (and fix debian/rules to not re-add it).
    + Bump Standards-Version to 3.9.2 (no change required).

  [ Philipp Kern ]
  * Add an extra tweaked version of d390.ins for s390 booting. The
    Hardware Management Console needs the file to be in the root
    directory.

  [ Robert Millan ]
  * Add kfreebsd 9. Closes: #650926
  * Add graphical installer image for kfreebsd-amd64. Closes: #651530
  * generate_d-i+k_list: Add ufutils. Closes: #662234

 -- Steve McIntyre <93sam@debian.org>  Fri, 04 May 2012 16:13:42 +0100

=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Debian CD Group <debian-cd@lists.debian.org>
Uploaders: Raphaël Hertzog <hertzog@debian.org>, Santiago Garcia Mantinan <manty@debian.org>, Steve McIntyre <93sam@debian.org>
Build-Depends: debhelper (>= 5)
Build-Depends-Indep: tofrodos
Standards-Version: 3.9.2
Vcs-Svn: svn://svn.debian.org/debian-cd/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-cd/trunk?op=log

Package: debian-cd
Architecture: all
Depends: ${misc:Depends}, curl, perl, dpkg-dev, cpp, libdigest-md5-perl, libdigest-sha-perl, tofrodos, apt (>= 0.3.11.1), make, genisoimage, lynx-cur | lynx, grep-dctrl, bc, libcompress-zlib-perl, bzip2, xorriso
Recommends: hfsutils, netpbm, syslinux-common
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

## debian-cd 3.1.11

=== Makefile ===
--- 
+++ 
@@ -295,9 +295,10 @@
 		if [ "$(INSTALLER_CD)"x = "1"x ] ; then \
 			: ; \
 		elif [ "$(INSTALLER_CD)"x = "2"x -o "$(INSTALLER_CD)"x = "C"x ] ; then \
-			echo -e "mawk" >>$(BDIR)/rawlist; \
+			echo "mawk" >>$(BDIR)/rawlist; \
 		else \
-			echo -e "mawk\nexim4-daemon-light" >>$(BDIR)/rawlist; \
+			echo "mawk" >>$(BDIR)/rawlist; \
+			echo "exim4-daemon-light" >>$(BDIR)/rawlist; \
 		fi; \
 	fi

=== debian/changelog ===
debian-cd (3.1.11) unstable; urgency=low

  [ Steve McIntyre ]
  * Merge x86 EFI support from the EFI_support branch (Closes: #658352)
    + Pull in grub-efi for amd64 and i386
    + Lots of extra code in boot-x86:
      - pull grub EFI pieces out of the latest debian-cd_info.tar.gz
        blobs in d-i, if they're there. If so, use them to make x86 images
        bootable via EFI (both via CD and USB)
      - parse the isolinux menus already provided in the d-i build and
        generate equivalent grub menus, complete with themes for a
        reasonable layout with graphics and titles.
      - depending more and more on xorriso rather than genisoimage...
  * Add version-tracking into dependency sorting. Closes: #687949)
    + Use/parse output from a newer version of apt so that "apt-cache
      depends" will include version information on dependencies.
    + All tracking of packages now include versions, so we pass around
      hashes of {package name, comparison op, version} everywhere instead
      of simply passing package names as strings.
    + Add the APT::Cache::ShowVersion=1 option to apt-cache calls to
      turn on version reporting. Needs a locally-patched version of apt
      *for now*, but expecting that to be fixed for the Wheezy
      release. The new code degrades gracefully if version info is not
      available.
    + Add a dependency on libdpkg-perl for version comparison code.
  * Improve architecture support in which_deb. Closes: #695244
    + Check all the architectures available in the archive if we're not
      specifically told which to use (e.g. on source builds)
    + If we fail to find packages/sources for the specified package, say
      so and bail out properly.
  * Switch boot-x86 to depend on xorriso totally rather than genisoimage
    now; working UEFI support needs it. We also need very recent (1.2.6)
    xorriso for various bugfixes, ideally.

 -- Steve McIntyre <93sam@debian.org>  Wed, 26 Sep 2012 01:09:13 +0100

debian-cd (3.1.10) unstable; urgency=low

  [ Steve McIntyre ]
  * Don't exclude all the udebs for s390. Some users really do need them
    (loading from a CD/DVD used over the network). Closes: Bug #673576
  * Explicitly add s390-tools and sysconfig-hardware for s390.
  * Tweak sort_deps:
    + Track whether a dependency chain is caused by a hard dependency
      (Depends) or soft (Recommends/Suggests). If we fail to add a package
      down the chain on a *soft* dependency, don't invalidate the entire
      chain.
    + When checking OR dependencies, *first* check to see if any of the
      options are already installed *before* trying to install the first
      option. Helps a lot with circular deps such as task-lxde-desktop ->
      task-desktop -> (task-gnome-desktop | task-lxde-desktop | etc.); in
      this case, of course task-lxde-desktop should satisfy the OR dep.
  * Tweak powerpc boot options, using 32/64 bit detection in yaboot at
    boot time. Thanks to Milan Kupcevic for the patch. Closes: #678066
  * Tweak boot-load-size for ia64 to make CDs boot again. Closes: #678883.
    Thanks to Stephan Schreiber for the patch. Tweak all the other
    ElTorito-booting arches in a similar fashion.

  [ Joey Hess ]
  * Clean up forcd1, removing twm, wmaker, wmakerconf, pump,
    menu (pulled in by desktop tasks),
    aptitude (pulled in by debootstap, and may be demoted to optional),
    alsa-utils, alsa-base (pulled in by task-desktop),
    mdetect, read-edid (no longer used by xorg),
    grub (handed by generate_di+k_list),
    deborphan, debfoster, localepurge (expert user stuff),
    chdrvfont (no such package any more),
    discover, popularity-contest, wpasupplicant, openssh-server
    (in generate_di+k_list),
    gnupg (pulled in by debootstrap)
  * Updated generate_di+k_list to match more closely the current
    packages d-i apt-installs.
  * Further trim forcd1, removing lots of historical cruft, and adding
    comments explaining the rationalle for the remaining packages.

 -- Steve McIntyre <93sam@debian.org>  Fri, 24 Aug 2012 14:50:13 +0100

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,8 @@
 
 Package: debian-cd
 Architecture: all
-Depends: ${misc:Depends}, curl, perl, dpkg-dev, cpp, libdigest-md5-perl, libdigest-sha-perl, tofrodos, apt (>= 0.3.11.1), make, genisoimage, lynx-cur | lynx, grep-dctrl, bc, libcompress-zlib-perl, bzip2, xorriso
-Recommends: hfsutils, netpbm, syslinux-common
+Depends: ${misc:Depends}, curl, perl, dpkg-dev, cpp, libdigest-md5-perl, libdigest-sha-perl, tofrodos, apt (>= 0.3.11.1), make, xorriso | genisoimage, lynx-cur | lynx, grep-dctrl, bc, libcompress-zlib-perl, bzip2, libdpkg-perl
+Recommends: hfsutils, netpbm, syslinux-common, mtools
 Description: Tools for building (Official) Debian CD set
  Debian-cd is the official tool for building Debian CD set since the potato
  release. It was formerly called YACS (for Yet Another CD Script).

## debian-cd 3.1.13

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,12 @@
 TASK=Debian-generic
 endif
 ifndef MKISOFS
+ifneq (,$(filter i386 amd64,$(ARCHES)))
+export MKISOFS=xorriso
+export MKISOFS_OPTS=-as mkisofs -r -checksum_algorithm_iso md5,sha1
+else
 export MKISOFS=$(shell which genisoimage mkisofs | head -1)
+endif
 endif
 ifndef MKISOFS_OPTS
 #For normal users
@@ -32,6 +37,12 @@
 ifndef HOOK
 HOOK=$(BASEDIR)/tools/$(CODENAME).hook
 endif
+ifndef ARCHIVE_KEYRING_PACKAGE
+ARCHIVE_KEYRING_PACKAGE=debian-archive-keyring
+endif
+ifndef ARCHIVE_KEYRING_FILE
+ARCHIVE_KEYRING_FILE=usr/share/keyrings/debian-archive-keyring.gpg
+endif
 
 export BUILD_DATE=$(shell date -u +%Y%m%d-%H:%M)
 export ARCHES_NOSRC=$(shell echo $(ARCHES) | sed 's/source//')
@@ -50,6 +61,9 @@
 endif
 ifneq (${ARCH_MKISOFS_OPTS},)
     MKISOFS_OPTS = ${ARCH_MKISOFS_OPTS}
+endif
+ifndef DEBOOTSTRAP_OPTS
+DEBOOTSTRAP_OPTS=--no-check-gpg
 endif
 
 ## Internal variables  
@@ -102,6 +116,9 @@
 endif
 ifndef CODENAME
 	@echo CODENAME undefined -- set up CONF.sh; false
+endif
+ifndef DISKTYPE
+	@echo DISKTYPE undefined -- set up CONF.sh; false
 endif
 ifndef OUT
 	@echo OUT undefined -- set up CONF.sh; false
@@ -215,11 +232,32 @@
 		fi; \
 	done;
 	:> $(ADIR)/status
-    # Updating the apt database
+
+	# Set up keyring so apt doesn't complain
+	@echo "Setting up archive-keyring"
+	$(Q)mkdir -p $(TDIR)/archive-keyring
+	$(Q)dpkg -x $(MIRROR)/$(shell $(which_deb) $(MIRROR) $(CODENAME) $(ARCHIVE_KEYRING_PACKAGE)) $(TDIR)/archive-keyring
+	$(Q)for ARCH in $(ARCHES); do \
+		mkdir -p $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
+		ln -s $(TDIR)/archive-keyring/$(ARCHIVE_KEYRING_FILE) $(ADIR)/$(CODENAME)-$$ARCH/apt/trusted.gpg.d; \
+	done
+
+	# Updating the apt database
 	$(Q)for ARCH in $(ARCHES); do \
 		export ARCH=$$ARCH; \
 		$(apt) update; \
 	done
+
+	# If we're doing a build using d-i from sid, we'll need sid sources too
+	if [ "$(INC_SOURCE)"x = "yes"x ] && \
+		[ "$(DI_CODENAME)"x != ""x ] && \
+		[ "$(DI_CODENAME)"x != "$(CODENAME)"x ] ; then \
+		mkdir -p $(ADIR)/$(DI_CODENAME)-source/apt/preferences.d ; \
+		:> $(ADIR)/$(DI_CODENAME)-source/status ; \
+		export CODENAME=$(DI_CODENAME); \
+		export ARCH=source; \
+		$(apt) update; \
+	fi
     #
     # Checking the consistency of the standard system
     # If this does fail, then launch make correctstatus
@@ -309,7 +347,7 @@
 				[ -z "$$BINCLUDE" ] || BINCLUDE="--include=$$BINCLUDE"; \
 				BEXCLUDE=`[ -n "$(BASE_EXCLUDE)" ] && cat $(BASE_EXCLUDE) | tr "\n" "," | sed 's!,$$!!g'`; \
 				[ -z "$$BEXCLUDE" ] || BEXCLUDE="--exclude=$$BEXCLUDE"; \
-				debootstrap --arch $$ARCH \
+				debootstrap $(DEBOOTSTRAP_OPTS) --arch $$ARCH \
 				            --print-debs \
 				            $$BINCLUDE $$BEXCLUDE \
 				            $(CODENAME) \
@@ -338,7 +376,7 @@
 	fi; \
 	if [ "$(SOURCEONLY)"x != "yes"x ] ; then \
 		cat $(TASKDIR)/$(TASK) | \
-		cpp -nostdinc -nostdinc++ -P -undef $$ARCHDEFS $$VARIANTDEFS\
+		cpp -nostdinc -P -undef $$ARCHDEFS $$VARIANTDEFS\
 	   		$$ARCHUNDEFS -U i386 -U linux -U unix \
 		    -DFORCENONUSONCD1=0 \
 		    -I $(TASKDIR) - - >> $(BDIR)/rawlist; \
@@ -356,37 +394,3 @@
 # Build a nice list without doubles and without spaces
 genlist: ok $(BDIR)/list
 $(BDIR)/list: $(BDIR)/rawlist
-	@echo "Generating the complete list of packages to be included in $(BDIR)/list..."
-	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
-	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
-		  $(BDIR)/rawlist \
-		  > $(BDIR)/list
-
-## IMAGE BUILDING ##
-
-image-trees: ok genlist
-    # Use sort_deps to do the dependency sorting
-	$(Q)for ARCH in $(ARCHES_NOSRC); do \
-		ARCH=$$ARCH $(sort_deps) $(BDIR)/list; \
-	done
-	$(Q)if [ "$(SOURCEONLY)"x = "yes"x ] ; then \
-		$(grab_source_list) $(BDIR) $(ADIR) $(BDIR)/list $(BDIR)/packages; \
-	else \
-		$(merge_package_lists) $(BDIR) $(ADIR) "$(ARCHES)" $(BDIR)/packages; \
-	fi
-	$(Q)if [ "$(INC_SOURCE)"x = "yes"x ] ; then \
-		grep ^source $(BDIR)/packages > $(BDIR)/packages.source; \
-	fi
-	$(Q)$(BASEDIR)/tools/make_disc_trees.pl $(BASEDIR) $(MIRROR) $(TDIR) $(CODENAME) "$(ARCHES)" "$(MKISOFS)" "$(MKISOFS_OPTS) $(JIGDO_OPTS)"
-
-images: ok $(OUT) $(BDIR)/md5-check
-	$(Q)$(make_image) "$(BDIR)" "$(ARCHES)" "$(OUT)" "$(DEBVERSION)" "$(MIRROR)" "$(MKISOFS)" "$(MKISOFS_OPTS)" "$(JIGDO_OPTS)" "$(jigdo_cleanup)"
-
-check-number-given:
-	@test -n "$(CD)" || (echo "Give me a CD=<num> parameter !" && false)
-
-# Generate only one image number $(CD)
-image: check-number-given images
-
-# Calculate the md5sums for the images (if available), or get from templates
-imagesums:

=== debian/changelog ===
debian-cd (3.1.13) unstable; urgency=medium

  * The traditional "last upload before the stable release" upload...

  [ Robert Spencer ]
  * Use ARCHIVE_KEYRING_PACKAGE and ARCHIVE_KEYRING_FILE parameters to
    not hardcode debian-archive-keyring and let derivatives use their
    own keyring.
  * Add further support for missing win32-loader.ini. Closes: #705594
  * Allow for override of distro name etc. in grub.cfg for EFI boot too.
    Closes: #705610

  [ Steve McIntyre ]
  * Tweak handling of {udeb,base}_{include,exclude} files so multi-arch
    builds should work better. Closes: #703436
  * Remove the dpkg check for debootstrap version before passing the
    --no-check-gpg option; we're not going to support debootstrap versions
    so old that they don't support this flag, *and* the dpkg-query call
    doesn't give us the right version anyway - we're using an extracted
    copy from the archive, not the one that (might be) installed on our
    build machine.

 -- Steve McIntyre <93sam@debian.org>  Tue, 30 Apr 2013 22:54:32 +0100

debian-cd (3.1.12) unstable; urgency=low

  [ Steve McIntyre ]
  * When building source-only discs, cope with having multiple different
    versions of a source package:
    + make_disc_trees.pl now tracks arrays of packages when parsing
      apt-cache output
    + We'll now pull in all the extra packages included in Sources.gz
      because of Built-Using.
  * Add support for Built-Using:
    + tools/sort_deps: parse out Built-Using from Packages files too and
      pass any such data on to tools/merge_package_lists
    + tools/merge_package_lists: if we have any built-using source
      packages listed when doing a combined binary/source set, add them in
      the same way as existing listed sources.
  * Other bug fixes in tools/merge_package_lists:
    + Fix handling of multi-line Binary: fields
    + Print out the accumulated size of source packages in output also
      (fix to printf format string)
  * Update Vcs-Browser
  * Make sure the DEBIAN_KERNEL placeholder in README.* is replaced;
    switch from cpp to sed for that so it works inside quoted
    text. Closes: #699198
  * Deal with syslinux version 5.x needing to install more files for
    bootable x86 media. Thanks to Daniel Baumann for the path.
    Closes: #699884

  [ Raphaël Hertzog ]
  * Update Makefile to set MKISOFS to xorriso by default when building
    images for i386/amd64. Otherwise a build that doesn't set MKISOFS
    and MKISOFS_OPTS fails.
  * Update tools/boot/wheezy/boot-x86 to not look for syslinux's source
    if $ARCHIVE_EXTRACTED_SOURCES is not set and modify CONF.sh
    to not set it by default. That option is only meaningful for
    official builds that result in a copy of the sources on the given URL.
  * Add dosfstools to Recommends since it's required by
    tools/boot/wheezy/boot-x86 for EFI support. It can't be added to Depends
    because it's not available on non-Linux systems.
  * Use debootstrap --no-check-gpg by default since many local mirrors
    are not signed (such as temporary mirrors created by simple-cdd).

  [ Steve McIntyre ]
  * Update boot-mipsel and boot-hppa to use the which_deb script for
    better safety when extracting boot loader files.
  * Update all the relevant boot-* scripts to do the right thing when
    extracting packages and sources, depending on
    $ARCHIVE_EXTRACTED_SOURCES as above
  * Add extra text to boot messages on powerpc to tell people about how to
    select a different desktop. Thanks to Rick Thomas for the
    text. Tweaked slightly to list the default on the current disc too.

  [ Robert Spencer ]
  * Extract debian-archive-keyring when setting up apt to avoid error
    messages about missing keys. Closes: #703431
  * Fix cpp warning in Makefile. Closes: #703432
  * Correct usage of dpkg-architecture to fix errors. Closes: #703487

  [ Steve McIntyre ]
  * Allow for override of DISKINFO base text; Closes: #695080

 -- Steve McIntyre <93sam@debian.org>  Mon, 01 Apr 2013 02:32:44 +0100

=== debian/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
 Build-Depends-Indep: tofrodos
 Standards-Version: 3.9.2
 Vcs-Svn: svn://svn.debian.org/debian-cd/trunk
-Vcs-Browser: http://svn.debian.org/wsvn/debian-cd/trunk?op=log
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-cd/trunk/
 
 Package: debian-cd
 Architecture: all
 Depends: ${misc:Depends}, curl, perl, dpkg-dev, cpp, libdigest-md5-perl, libdigest-sha-perl, tofrodos, apt (>= 0.3.11.1), make, xorriso | genisoimage, lynx-cur | lynx, grep-dctrl, bc, libcompress-zlib-perl, bzip2, libdpkg-perl
-Recommends: hfsutils, netpbm, syslinux-common, mtools
+Recommends: hfsutils, netpbm, syslinux-common, mtools, dosfstools
 Description: Tools for building (Official) Debian CD set
  Debian-cd is the official tool for building Debian CD set since the potato
  release. It was formerly called YACS (for Yet Another CD Script).
